/* MACE_GO: MAximal Clique Enumerater - Greater size/Optimum */
/* ver 1.0 1/Sep/2005 Takeaki Uno   e-mail:uno@nii.jp, 
    homepage:   http://research.nii.ac.jp/~uno/index.html  */
/* This program is available for only academic use, basically.
   Anyone can modify this program, but he/she has to write down 
    the change of the modification on the top of the source code.
   Neither contact nor appointment to Takeaki Uno is needed.
   If one wants to re-distribute this code, do not forget to 
    refer the newest code, and show the link to homepage of 
    Takeaki Uno, to notify the news about this code for the users.
   For the commercial use, please make a contact to Takeaki Uno. */


#ifndef _mace_go_c_
#define _mace_go_c_

#define WEIGHT_DOUBLE
#define MACEGO_MAX 8

#include"sgraph.c"
#include"problem.c"


//int **PP->shift;    /* pointers to the positions of the current processing items in each transaction */


void MACEGO_error (){
  ERROR_MES = "command explanation";
  print_err ("mace_go MCqVe [options] input-filename [output-filename]\n\
M: enumerate maximal cliques, O: find maximum cliques\n\
q: no output to standard output, V:show progress\n\
e: edge_list format for input file\n\
[options]\n\
-l [num]:enumerate maximal cliques of size at least [num]\n\
-S [num]:stop after outputting [num] solutions\n\
-, [char]:give the separator of the numbers in the output\n\
-Q [filename]:replace the output numbers according to the permutation table given by [filename]\n\
# the 1st letter of input-filename cannot be '-'.n\
# if the output file name is -, the solutions will be output to standard output.\n");
  EXIT;
}


/***************************************************/
/*  read parameters from command line              */
/***************************************************/
void MACEGO_read_param (int argc, char *argv[], PROBLEM *PP){
  ITEMSET *II=&PP->II;
  int c=1;
  if ( argc < c+2 ){ MACEGO_error (); return; }
  II->lb = 2;

  if ( !strchr (argv[c], 'q') ){ II->flag |= SHOW_MESSAGE; PP->FF.flag |= SHOW_MESSAGE; }
  if ( strchr (argv[c], 'M') ) PP->problem = PROBLEM_MAXIMAL;
  else if ( strchr (argv[c], 'O') ) PP->problem = MACEGO_MAX;
  else error ("C command has to be specified", EXIT);
  if ( strchr (argv[c], 'V') ) II->flag |= SHOW_PROGRESS;
  if ( strchr (argv[c], 'e') ) PP->SG.flag |= LOAD_ELE;
  c++;

  while ( argv[c][0] == '-' ){
    switch (argv[c][1]){
      case 'l': II->lb = atoi (argv[c+1]);
      break; case 'S': II->max_solutions = atoi(argv[c+1]);
      break; case ',': II->separator = argv[c+1][0];
      break; case 'Q': PP->outperm_fname = argv[c+1];
      break; default: goto NEXT;
    }
    c += 2;
    if ( argc < c+1 ){ MACEGO_error (); return; }
  }

  NEXT:;
  PP->SG.fname = argv[c];
  if ( argc>c+1 ) PP->output_fname = argv[c+1];
}


// v.end: }[N̑B݂̉̃TCY ȂAANeBui݌ĂOtɊ܂܂jANeBuȒ_́Aitemcand Ɋi[B
//  eŃANeBuɂȂƂ݂̂CNgčXVBIɂ̓fNg
// v.v: }i[BANeBuȂƂ낪Oɗ悤ɕāAinduced subgraph \Bieōsj  IɌɖ߂KvȂ
//    }iאڃXgj́A_̑傫Ń\[gĂȂƂɒ
// v.t: ANeBuȕ̍Ō̗vfBeŁAۂɍXVAIɌɖ߂Bɖ߂Ƃɂv.end ANeBuł肽ǂ邱ƂsA̒lL邱Ƃ͂ȂB
//   ɖ߂ƂA݉̃TCY0 ͓̎ʈBz|C^̍𗘗pĕ

// v[jÓA钸_ v ɗאڂ}AANeBü̍ŏ̕Ɍł߁AɂĂ͍ċAsȂƂŎB
// CAND  }XǵA[vɗאڂ]AivjAvɗאڂȂ̂Ƀ\[gAƂŕׂĂBv ̍ċAÍACAND.t CNgA}XgɂĂ v ł̂t CNgBŃOt v ǉ̂ƓƂɂȂB

// II.add ɁẢ݂ɗאڂ钸_SĂi[Bgċɑ含𔻒肷B

// PP->itemcand: vertices to be added (only the second part)
// PP->II.add: all vertices adjacent to 

void MACEGO_sub (PROBLEM *PP, QUEUE *Q, QUEUE_INT **end, QUEUE_INT v){
  QUEUE_INT *z, *y, *yy= Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  FLOOP (y, Q->v, *end)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  if ( yy+1<y ){
    FLOOP (z, yy+1, y)
        if ( *z == v ){ SWAP_INT (*yy, *z); break; }   // move v to the earliest
    if ( PP->problem & MACEGO_MAX ) qsort_QUEUE_INT (yy+1, y-yy-1, 1);
  }
  *end = yy;
}
void MACEGO_sub2 (PROBLEM *PP, QUEUE *Q, QUEUE_INT **end){
  QUEUE_INT *y, *yy=Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  FLOOP (y, Q->v, *end)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  *end = yy;
}  
void MACEGO_recov (PROBLEM *PP, QUEUE *Q, QUEUE_INT **end){
  QUEUE_INT t=PP->II.itemset.t+1;
  QUEUE *E = PP->SG.edge.v;
  for ( ; E[**end].end==t ; (*end)++);
}
void MACEGO_sub_ (PROBLEM *PP, QUEUE *Q, QUEUE_INT v){
  QUEUE_INT *z, *y, *yy= Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  MQUE_FLOOP (*Q, y)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  if ( yy+1<y ){
    FLOOP (z, yy+1, y)
        if ( *z == v ){ SWAP_INT (*yy, *z); break; }   // move v to the earliest
  if ( PP->problem & MACEGO_MAX ) qsort_QUEUE_INT (yy+1, y-yy-1, 1);
  }
  Q->t = yy - Q->v;
}
void MACEGO_sub2_ (PROBLEM *PP, QUEUE *Q){
  QUEUE_INT *y, *yy=Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  MQUE_FLOOP (*Q, y)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  Q->t = yy - Q->v;
}  
void MACEGO_recov_ (PROBLEM *PP, QUEUE *Q){
  QUEUE_INT *y, t=PP->II.itemset.t+1;
  QUEUE *E = PP->SG.edge.v;
  for (y=Q->v+Q->t ; E[*y].end==t ; y++);
  Q->t = y - Q->v;
}

/******************************************************************/
/* iteration of clique enumeration   */
/******************************************************************/
void MACEGO_max (PROBLEM *PP, QUEUE *prv){
  ITEMSET *II=&PP->II;
  QUEUE_INT *x, *v, u, m=0, p=*(prv->v), pt = prv->t;
  QUEUE *Q = PP->SG.edge.v;
  
//printf ("%d\n", II->itemset.t + II->lb );

  II->iters++;
printf ("================ "); QUEUE_print__ (&II->itemset);
printf ("======== "); QUEUE_print__ (prv);
//  MQUE_FLOOP (*prv, x){ printf ("%d: ", *x); QUEUE_print__ (&Q[*x]); }

//  if ( II->lb >= 2 ) 
//      MACEGO_rm_non_common_edge (G, II->lb, &PP->itemcand, PP->occ_w, &PP->itemjump);

    // choose the maximum degree vertex p
  MQUE_FLOOP (*prv, v) if (Q[*v].t > m ){ m= Q[*v].t; p = *v; }
  if ( m < II->lb ) return;   // every vertex violates the lower bound
  if ( m == 0 ){
    if ( II->lb <= 0 ){
      II->lb = 1;
      QUEUE_cpy (&PP->itemcand, &PP->II.itemset);
      QUE_INS (PP->itemcand, prv->v[0]);
    }
    return;
  }

    // sort the edge list according neighbors of p

// for each edge array list adjacent to v, partition the vertices in it so that vertices adjacent to v are lacated at the first half. the size (.t) is changed to the end of the first half
// t has to be "itemset.t"
  MQUE_FLOOP (Q[p], x) Q[*x].end++;   // increment the mark, adjacent to v
//  MQUE_FLOOP (*prv, x) if ( *x != p ) MACEGO_sub (PP, &Q[*x], p);
//  MACEGO_sub (PP, prv, p);

  FLOOP (m, prv->t, pt){
    u = prv->v[m];
printf ("loop for %d (%d,%d)\n", u, Q[u].t, II->lb);
//    if ( Q[u].t < II->lb ) continue;   // violate the lower bound

    if ( Q[u].t > 0 ){
      if ( u != p ){
    MQUE_FLOOP (Q[u], x) if ( Q[*x].v[Q[*x].t] != u ) printf ("okiiii\n");
        MQUE_FLOOP (Q[u], x) Q[*x].end++;   // increment the mark, adjacent to v
//        MQUE_FLOOP (Q[u], x) MACEGO_sub2 (PP, &Q[*x]);
      }

      QUE_INS (II->itemset, u);  // insert vertex
      II->lb--;
//        MACEGO_max (PP, &Q[u]);    // recursive call
      II->lb++;
      II->itemset.t--;
//printf ("ret: %d\n", u);
//      MQUE_FLOOP (Q[u], x) MACEGO_recov (PP, &Q[*x]);
      MQUE_FLOOP (Q[u], x) Q[*x].end--;    // decrement the mark, to recover
    }
//     else if ( II->lb <= 0 ){
//      II->lb++;
//      QUE_INS (II->itemset, u);  // insert vertex
//      QUEUE_cpy (&PP->itemcand, &PP->II.itemset);
//    }
    MQUE_FLOOP (Q[u], x) if ( Q[*x].v[Q[*x].t] != u ) printf ("okasii\n");
    MQUE_FLOOP (Q[u], x) Q[*x].t++;   // decrement the mark, to recover
  }
  prv->t = pt;
}

// edge.v[].v ́A[].s ܂łAprv ɓĂAƂȂ悤ɂI

/******************************************************************/
/* iteration of clique enumeration   */
/******************************************************************/
//void MACEGO_iter (PROBLEM *PP, QUEUE *prv){
void MACEGO_iter (PROBLEM *PP, QUEUE *prv, QUEUE_INT *prv_t){
  ITEMSET *II=&PP->II;
  QUEUE_INT *x, *v, *vv, *ptt, *pt=prv->v, m=0, p=*pt, t=II->itemset.t+2;
  QUEUE_ID it=PP->itemcand.t;
  QUEUE *Q = PP->SG.edge.v;

  II->iters++;
//QUEUE_print__ (&II->itemset);
//printf ("###  "); QUEUE_print (prv); 

    // choose the maximum degree vertex p
  FLOOP (x, prv->v, prv_t) Q[*x].end++;
  FLOOP (x, prv->v, prv_t){
    if ( Q[*x].t == 0 ){  // adding *x generates a maximal clique!
      if ( II->lb <= 1 ){   // every vertex violates the lower bound
        QUE_INS (II->itemset, *x);  
        ITEMSET_output_itemset (II, NULL, 0);
        II->itemset.t--;
      }
    } else {
      vv = Q[*x].v; FLOOP (v, Q[*x].v, PP->shift[*x]){
        if ( Q[*v].end == t ) // compute N[*x]\cap prv
            if ( v != vv ) SWAP_QUEUE_INT (*v, *vv); vv++;
      }
      if ( vv-Q[*x].v > m ){ m = vv-Q[*x].v; p = *x; }
      if ( vv > Q[*x].v ){
        if ( x > pt ) SWAP_QUEUE_INT (*x, *pt);
        pt++;
      }
    }

  FLOOP (x, prv->v, prv_t) Q[*x].end--;
  if ( m < MAX(1,II->lb) ) return;   // every vertex violates the lower bound

//  if ( II->lb >= 2 ) 
//      MACEGO_rm_non_common_edge (G, II->lb, &PP->itemcand, PP->occ_w, &PP->itemjump);


// for each edge array list adjacent to v, partition the vertices in it so that vertices adjacent to v are lacated at the first half. the size (.t) is changed to the end of the first half
// t has to be "itemset.t"
  FLOOP (x, Q[p].v, PP->shift[p]) if ( Q[*x].end == t-1 ) Q[*x].end++;   // increment the mark, adjacent to v
  MACEGO_sub (PP, prv, &prv_t, p);

//  reallocz (PP->itemary, PP->root, PP->dir+prv->t ,EXIT); //
  for ( ; pt<prv_t ; pt++){
//printf ("loop for %d\n", *pt);
    ptt = pt;
    if ( *pt != p ){
      FLOOP (x, Q[*pt].v, PP->shift[*pt]) if ( Q[*x].end == t-1 ) Q[*x].end++;   // increment the mark, adjacent to v
      MACEGO_sub2 (PP, prv, &pt);
    }
    FLOOP (x, Q[*pt].v, PP->shift[*pt]){
      if ( Q[*x].end == t ){
//        PP->itemary[PP->dir++] = Q[*x].t;
        MACEGO_sub2 (PP, &Q[*x], &PP->shift[*x]);
      }
    }
    MACEGO_sub2 (PP, &PP->itemcand, );
    QUE_INS (II->itemset, *pt);  // insert vertex
//printf ("rec: %d\n", *pt);
    II->lb--;
      MACEGO_iter (PP, prv, pt);    // recursive call
    II->lb++;
    II->itemset.t--;
//printf ("return: %d\n", *pt);
    PP->itemcand.t = it;
    pt = ptt;
    FLOOP (x, Q[*pt].v, PP->shift[*pt]) if ( Q[*x].end == t ) MACEGO_recov (PP, &Q[*x], &PP->shift[*x]);
//    MQUE_BLOOP (Q[*pt], x) if ( Q[*x].end == t ) Q[*x].t = PP->itemary[--PP->dir];
    FLOOP (x, Q[*pt].v, PP->shift[*pt]) if ( Q[*x].end == t ) Q[*x].end--;    // decrement the mark, to recover
//QUEUE_print__ (&Q[2]);
//FLOOP (common_INT, 0, 15) printf ("(%d,%d):", common_INT, Q[common_INT].end); printf ("\n");
  }
}

/***************************************************/
/*  main routine                                   */
/***************************************************/
int MACEGO_main (int argc, char *argv[]){
  PROBLEM PP;
  SGRAPH *G=&PP.SG;
  QUEUE_INT i;
  
  PROBLEM_init (&PP);
  MACEGO_read_param (argc, argv, &PP);
if ( ERROR_MES ) return (1);

  G->flag |= LOAD_INCSORT + LOAD_RM_DUP + LOAD_EDGE;
  if ( PP.problem & MACEGO_MAX ) PP.II.flag |= ITEMSET_ADD;
  PROBLEM_load (&PP);  if (ERROR_MES) return(1);
  
  PROBLEM_alloc (&PP, G->edge.t, G->edge.t, G->edge.eles, NULL, PROBLEM_ITEMCAND +PROBLEM_ITEMJUMP);  if (ERROR_MES) return(1);  // +PROBLEM_OCC_W
  malloc2 (PP->shift, G->edge.t, return(1));
  FLOOP (i, 0, G->edge.t){
    PP->shift[i] = G->edge.v[i].v + G->edge.v[i].t;
    G->edge.v[i].end = 1;  // pur vertex mark
    G->edge.v[i].v[G->edge.v[i].t] = G->edge.t; // put endmark
    PP.itemcand.v[i] = PP.itemjump.v[i] = i;// init CAND
  }
  G->edge.v[G->edge.t].end = 0;
  PP.itemjump.t = G->edge.t;
  if ( !(PP.problem & MACEGO_MAX) ) PP.itemcand.t = G->edge.t;

//  MACEGO_rm_small_deg (G, PP.II.lb);
//  SGRAPH_sort_node (G, 1);
//  ST_MAX (m, pivot, G->edge.v, t, 0, G->edge.t);
  
//SGRAPH_print (G);

  if ( PP.problem & MACEGO_MAX ){ MACEGO_max (&PP, &PP.itemjump); QUEUE_print (&PP.itemcand); }
  else { MACEGO_iter (&PP, &PP.itemjump); ITEMSET_last_output (&PP.II); }
  
  PROBLEM_end (&PP);
  return (ERROR_MES?1:0);
}

/*******************************************************************************/
#ifndef _NO_MAIN_
#define _NO_MAIN_
int main (int argc, char *argv[]){
  return (MACEGO_main (argc, argv) );
}
#endif
/*******************************************************************************/


#endif

